schedule function horse_traps:1s 1s

#ZOMBIE HORSE AMBIENT SOUND
execute as @e[type=skeleton_horse,tag=horse_traps.zombie_h,predicate=horse_traps:chance_5] at @s run playsound entity.zombie_horse.ambient neutral @a ~ ~ ~

#POISON HORSES
execute as @e[tag=horse_traps.poison] at @s run execute unless data entity @s Passengers run function horse_traps:poison

#REMOVE INVISIBILITY
execute as @e[type=horse,tag=horse_traps.invisible,tag=horse_traps.trap,nbt={OnGround:1b}] at @s run tag @s remove horse_traps.invisible

#UNDEAD HORSE TAMING HINT
execute as @a[gamemode=!spectator,advancements={horse_traps:tame/undead_horse=false}] at @s run execute if entity @e[type=zombie_horse,tag=!smithed.entity,tag=!horse_traps.despawn,distance=..2,nbt=!{Tame:1b}] run advancement grant @s only horse_traps:tame/undead_horse
execute as @a[gamemode=!spectator,advancements={horse_traps:tame/undead_horse=false}] at @s run execute if entity @e[type=skeleton_horse,tag=!smithed.entity,tag=!horse_traps.despawn,distance=..2,nbt=!{Tame:1b}] run advancement grant @s only horse_traps:tame/undead_horse

#UNDEAD HORSE EATING HINT
execute as @a[advancements={horse_traps:ride_horse/skeleton=false},predicate=horse_traps:riding/skeleton_horse] at @s run advancement grant @s only horse_traps:ride_horse/skeleton
execute as @a[advancements={horse_traps:ride_horse/zombie=false},predicate=horse_traps:riding/zombie_horse] at @s run advancement grant @s only horse_traps:ride_horse/zombie

#BOSSBARS
execute as @a[scores={horse_traps.sb=1}] at @s run execute unless entity @e[type=skeleton,tag=horse_traps.angryat,distance=..64] run execute unless entity @e[type=skeleton_horse,tag=horse_traps.despawn,distance=..64] run scoreboard players reset @s horse_traps.sb
execute as @a[scores={horse_traps.zb=1}] at @s run execute unless entity @e[type=drowned,tag=horse_traps.angryat,distance=..64] run execute unless entity @e[type=zombie_horse,tag=horse_traps.despawn,distance=..64] run scoreboard players reset @s horse_traps.zb
bossbar set horse_traps:skeleton players @a[scores={horse_traps.sb=1}]
bossbar set horse_traps:zombie players @a[scores={horse_traps.zb=1}]

#APPLY EFFECTS
execute as @e[tag=horse_traps.fire_resistant] at @s run function horse_traps:fire_resistance
execute as @e[tag=horse_traps.invisible] at @s run effect give @s invisibility 2 0 true

#STACK
execute as @e[type=skeleton_horse,limit=1,sort=random,tag=horse_traps.fire_resistant,tag=!horse_traps.zombie_h] at @s run execute if entity @e[type=skeleton,tag=horse_traps.angryat,predicate=horse_traps:angry,distance=..7] run tp @e[type=skeleton_horse,tag=horse_traps.fire_resistant,distance=0.1..2] ~ ~ ~

#ANGRYAT
execute as @e[type=drowned,tag=horse_traps.angryat,predicate=!horse_traps:angry,sort=random] at @s run execute if entity @a[gamemode=!creative,gamemode=!spectator,scores={horse_traps.zb=1}] run summon snowball ~ ~2.4 ~ {Tags:["horse_traps.trigger","smithed.entity","smithed.strict"],Item:{id:"minecraft:warped_button",count:1}}
execute as @e[type=skeleton,tag=horse_traps.angryat,predicate=!horse_traps:angry,sort=random] at @s run execute if entity @a[gamemode=!creative,gamemode=!spectator,scores={horse_traps.sb=1}] run summon snowball ~ ~2.4 ~ {Tags:["horse_traps.trigger","smithed.entity","smithed.strict"],Item:{id:"minecraft:warped_button",count:1}}
execute as @e[type=snowball,tag=horse_traps.trigger] at @s run data modify entity @s Owner set from entity @p[gamemode=!creative,gamemode=!spectator,limit=1,sort=nearest] UUID

#DESPAWN
execute as @e[type=horse,tag=horse_traps.trap,predicate=!horse_traps:thunder,predicate=!horse_traps:rain] at @s run summon lightning_bolt ~ ~ ~ {Tags:["smithed.entity"]}
execute as @e[type=horse,tag=horse_traps.trap,predicate=!horse_traps:thunder,predicate=!horse_traps:rain] at @s run function horse_traps:delete_current_entity
execute as @e[type=skeleton_horse,tag=!horse_traps.zombie_h,tag=horse_traps.fire_resistant,predicate=!horse_traps:thunder,predicate=!horse_traps:rain] at @s run execute unless entity @a[scores={horse_traps.sb=1}] run function horse_traps:delete_current_entity
execute as @e[type=skeleton_horse,tag=horse_traps.zombie_h,tag=horse_traps.fire_resistant,predicate=!horse_traps:thunder,predicate=!horse_traps:rain] at @s run execute unless entity @a[scores={horse_traps.zb=1}] run function horse_traps:delete_current_entity